<?php

/**
 * Plugin Name: Cxense plugin
 * Description: Setup site with cxense widgets
 * Version: 0.1.0
 * Author: Infomaker Scandinavia AB
 * Author URI: https://infomaker.se
 */

use Everyware\Plugin\Cxense\Widgets\ListWidget;
use Everyware\Plugin\Cxense\Widgets\CCEWidget;
use Everyware\Plugin\Cxense\PluginSettings;
use Everyware\Plugin\Cxense\PluginSettingsForm;
use Everyware\ProjectPlugin\Components\WidgetManager;
use Everyware\ProjectPlugin\Components\Adapters\PluginSettingsTabAdapter;
use Everyware\ProjectPlugin\Components\ComponentAdmin;
use Everyware\ProjectPlugin\Helpers\FileReader;
use Everyware\ProjectPlugin\ProjectPlugin;
use Infomaker\Everyware\Twig\ViewSetup;

if ( ! defined('WPINC') || ! class_exists(ProjectPlugin::class)) {
    exit;
}

ViewSetup::getInstance()->registerTwigFolder('cxense', __DIR__ . '/src/templates/');

$settings = PluginSettings::create();
ListWidget::setSettings($settings);
WidgetManager::register(ListWidget::class);
WidgetManager::register(CCEWidget::class);

if (is_admin()) {
    $settingsAdmin = new ComponentAdmin(
        new PluginSettingsForm(new FileReader(__FILE__)),
        $settings
    );

    ProjectPlugin::getInstance()->addSettingsTab(new PluginSettingsTabAdapter($settingsAdmin));
} else {
    $settings->renderScript();
}
