<?php declare(strict_types=1);

namespace Everyware\Plugin\Cxense;

class Api
{
    protected $url;
    protected $query = [];

    public function __construct(string $url)
    {
        $this->url = $url;
    }

    public function setQuery(array $query)
    {
        $this->query = $query;

        return $this;
    }

    public function getUrl()
    {
        return $this->url;
    }

    public function get()
    {
        if (!$this->url) return [];
        
        try {
          $response = wp_remote_get($this->buildUrl());

          if (!is_array($response) OR wp_remote_retrieve_response_code($response) !== 200) {
            return [];
          }

          $response = json_decode(wp_remote_retrieve_body($response), true);

          return $response['items'] ?? [];
        } catch (\Exception $e) {
          return [];
        }
    }

    protected function buildUrl()
    {
        return sprintf('%s?json=%s', $this->url, json_encode($this->query));
    }
}
