<?php declare(strict_types=1);

namespace Everyware\Plugin\Cxense;

use Everyware\ProjectPlugin\Components\ComponentSettingsRepository;
use Everyware\ProjectPlugin\Components\SettingsProviders\CollectionDbProvider;
use Infomaker\Everyware\Support\Storage\CollectionDB;

/**
 * Class PluginSettings
 * @package Everyware\Plugin\Cxense
 */
class PluginSettings extends ComponentSettingsRepository
{
    public const OPTION_NAME = 'ew_cxense_settings';

    private static $fields = [
        'api_url' => '',
        'cce_script_url' => 'https://cdn.cxense.com/cx.cce.js'
    ];

    public static function create()
    {
        return new static(new CollectionDbProvider(new CollectionDB(static::OPTION_NAME), static::$fields));
    }

    public function renderScript()
    {
        if ($script_url = $this->getValue('cce_script_url')) {
            wp_enqueue_script('cx-cce', $script_url);
        }
    }
}
